﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.78
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI 'ignore
	'
	Private m_gainP As Double
	Private m_gainI As Double
	Private m_gainD As Double
	'
	Private m_currentError As Double
	Private m_previousError As Double
	Private m_integral As Double
	Private m_output As Double
	'
	Private q0, q1, q2 As Double
	Private m_2previousError As Double
	Private m_2output As Double
	'
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(p As Double, i As Double, d As Double)
	'
	m_gainP = p
	m_gainI = i
	m_gainD = d
	'
	m_currentError = 0
	m_previousError = 0
	m_integral = 0
	m_output = 0
	'
	q0 = 0
	q1 = 0
	q2 = 0
	'
	m_2previousError = 0
	m_2output = 0
	'
End Sub

'
Public Sub setP(p As Double)
	'
	m_gainP = p
	'
End Sub

'
Public Sub setI(i As Double)
	'
	m_gainI = i
	'
End Sub 

'
Public Sub setD(d As Double)
	'
	m_gainD = d
	'
End Sub 


Public Sub setError(e As Double)
	'
	m_currentError = e
	'
End Sub

public Sub getError As Double
	'
	Return m_currentError
	'
End Sub

'differential equation of a PID controller
' dt = TimeStep
Public Sub Tick(dt As Double, intProcess As Int)
	'
	Select intProcess
		
		Case 0 ' simple PID caculation
			' Integral
'			If Abs(m_currentError) < .1 Then
			m_integral = dt * (m_integral + m_currentError) ' Sum of all errors + currrent
'			Else
'				m_integral = dt * m_integral ' Sum of all errors + currrent
'			End If
			' Differential
			Dim derivative As Double = (m_currentError - m_previousError) / dt
			' PID equation
			m_output = m_gainP * m_currentError + m_gainI * m_integral + m_gainD * derivative
			' memorizing of the current error for the next loop
			m_previousError = m_currentError
			'
		Case 1	' 
			' co-factors
			q0 = m_gainP + m_gainI * dt + m_gainD / dt
			q1 =-m_gainP -2 * m_gainD / dt
			q2 = m_gainD / dt
			'
			' PID equation
			m_output = m_2output + q0 * m_currentError + q1 * m_previousError + q2 * m_2previousError
			' memorizing of the current errors etc for the next loop
			m_2previousError = m_previousError
			m_previousError = m_currentError
			m_2output = m_output
			
	End Select
	
End Sub


Public Sub getOutput() As Double
	'
	Return m_output
	'
End Sub